// To compile the program  # gcc -o knob knob.c -lm

// If you want call this program you need call   # knob X Y
// Where X is the value coordinate X axis pointermouse and 
// Y is the value coordinate Y axis pointer mouse.
// These values are passed by the program GtkDialog 

#include <stdio.h> 
#include <stdlib.h> 
#include <string.h>
#include <math.h>
#define PI 3.14159
#define WIN_SIZE 300  // SIZE OF WINDOW KNOB
#define RADIO 150
#define STEP 10

void get_in_degree(int val);


int main (int argc, char *argv[])
{
float RADIANS, SINE, COSEN;
int i, DEGRED, DEGR, Py, Px, X, Y;
char ch[20];
     
   if (argc > 1)     // Get the numerical values of your mouse X and Y
     {
         X=atoi(argv[1]);
         Y=atoi(argv[2]);
 	 }
      else
        {
          printf("Enter the coordinates of the mouse X and Y.\n");
        }
	
  FILE *fp1;
	
  fp1 = fopen("/tmp/knob/DEGR.dat","r+");  // Open file with variable DEGR for change degree .
  if (fp1 == NULL)
 		exit(1);
 		
  fgets(ch,20,fp1);

  fclose(fp1);	
  
  DEGR=atoi(ch); 		

  DEGRED = 240 - DEGR;

  RADIANS=(DEGRED*PI)/180;
  SINE=sin(RADIANS);
  COSEN=cos(RADIANS);

  Py=(-1)*110*SINE+150;
   
  Px=110*COSEN+150;

  
   if (  ( DEGR < RADIO ) && ( Px < RADIO) && ( X < RADIO ) && ( Py > Y) && ( Y < 260 ) ) 
     {
       DEGR=DEGR+STEP; DEGRED=240-DEGR; sprintf(ch,"%d",DEGR); fp1 = fopen("/tmp/knob/DEGR.dat","w"); fputs( ch, fp1 );    
	   fclose(fp1); get_in_degree(DEGR);
     }       
     
   if ( ( DEGR > 0 ) &&( Px < RADIO) && ( X < RADIO ) && ( Py < Y)  && ( Y < 260 ) ) 
     {
       DEGR=DEGR-STEP; DEGRED=240-DEGR; sprintf(ch,"%d",DEGR); fp1 = fopen("/tmp/knob/DEGR.dat","w");
       fputs( ch, fp1 ); fclose(fp1);get_in_degree(DEGR);  	
     }       
      
     
   if ( ( Px < RADIO+1 ) && ( X > RADIO ) && ( Y < 260 ) ) 
     {
       DEGR=DEGR+STEP; DEGRED=240-DEGR; sprintf(ch,"%d",DEGR); fp1 = fopen("/tmp/knob/DEGR.dat","w");
       fputs( ch, fp1 ); fclose(fp1); get_in_degree(DEGR);      
       
     }       
      
   if ( ( Px > RADIO) && ( X > RADIO ) && ( Py > Y ) && ( Y < 260 ) ) 
     {
       DEGR=DEGR-STEP; DEGRED=240-DEGR; sprintf(ch,"%d",DEGR); fp1 = fopen("/tmp/knob/DEGR.dat","w");
       fputs( ch, fp1 ); fclose(fp1); get_in_degree(DEGR);	       	
     } 
           
    
   if ( ( Px > RADIO) && ( X > RADIO ) && ( Py < Y ) && ( Y < 260 ) && ( DEGR < 300 ) ) 
     {
       DEGR=DEGR+STEP; DEGRED=240-DEGR; sprintf(ch,"%d",DEGR); fp1 = fopen("/tmp/knob/DEGR.dat","w");
       fputs( ch, fp1 ); fclose(fp1); get_in_degree(DEGR);	
     }       

     
   if ( ( DEGR > RADIO-1 ) && ( Px > RADIO-1 ) && ( X < RADIO ) && ( Y < 260 ) ) 
     {
       DEGR=DEGR-STEP; DEGRED=240-DEGR; sprintf(ch,"%d",DEGR); fp1 = fopen("/tmp/knob/DEGR.dat","w");
       fputs( ch, fp1 ); fclose(fp1); get_in_degree(DEGR);	       
     }       
      
} 

// The next code replace variable "DEGRED" in file  imgini.svg for rotation degree value and copy in 
//  file img.svg later use for pixmap in Gtkdialog program.        

void get_in_degree(int val)
{
const char fileimgini[32] = "/tmp/knob/imgini.svg"; // original file
const char fileimg[32] = "/tmp/knob/img.svg";   //  pixmap file to use with the angle changed
const char var1[20] = "DEGRED";
char var2[20];
		
char buffer[122];
char *buff_ptr, *find_ptr;

	FILE *fp2, *fp3;
	
  	sprintf(var2,"%d",val);
  	
 	size_t find_len = strlen(var1);

	fp2 = fopen(fileimgini,"r");
	fp3 = fopen(fileimg,"w");

	while(fgets(buffer,122,fp2))
		{
			buff_ptr = buffer;
			while ((find_ptr = strstr(buff_ptr,var1)))
				{
				while(buff_ptr < find_ptr)
				fputc((int)*buff_ptr++,fp3);
				fputs(var2,fp3);
				buff_ptr += find_len;
       }
         fputs(buff_ptr,fp3);
    }

    fclose(fp3);
    fclose(fp2);
}
